"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var AuthZModule_1;
Object.defineProperty(exports, "__esModule", { value: true });
const common_1 = require("@nestjs/common");
const casbin = require("casbin");
const authz_guard_1 = require("./authz.guard");
const authz_constants_1 = require("./authz.constants");
const services_1 = require("./services");
let AuthZModule = AuthZModule_1 = class AuthZModule {
    static register(options) {
        const moduleOptionsProvider = {
            provide: authz_constants_1.AUTHZ_MODULE_OPTIONS,
            useValue: options || {}
        };
        let enforcerProvider = options.enforcerProvider;
        const importsModule = options.imports || [];
        if (!enforcerProvider) {
            if (!options.model || !options.policy) {
                throw new Error('must provide either enforcerProvider or both model and policy');
            }
            enforcerProvider = {
                provide: authz_constants_1.AUTHZ_ENFORCER,
                useFactory: () => __awaiter(this, void 0, void 0, function* () {
                    const isFile = typeof options.policy === 'string';
                    let policyOption;
                    if (isFile) {
                        policyOption = options.policy;
                    }
                    else {
                        policyOption = yield options.policy;
                    }
                    return casbin.newEnforcer(options.model, policyOption);
                })
            };
        }
        return {
            module: AuthZModule_1,
            providers: [
                moduleOptionsProvider,
                enforcerProvider,
                authz_guard_1.AuthZGuard,
                services_1.AuthZRBACService,
                services_1.AuthZManagementService
            ],
            imports: importsModule,
            exports: [
                moduleOptionsProvider,
                enforcerProvider,
                authz_guard_1.AuthZGuard,
                services_1.AuthZRBACService,
                services_1.AuthZManagementService
            ]
        };
    }
};
AuthZModule = AuthZModule_1 = __decorate([
    common_1.Global(),
    common_1.Module({
        providers: [],
        exports: []
    })
], AuthZModule);
exports.AuthZModule = AuthZModule;
//# sourceMappingURL=authz.module.js.map