"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const common_1 = require("@nestjs/common");
const authz_constants_1 = require("../authz.constants");
const defaultIsOwn = (ctx) => false;
exports.UsePermissions = (...permissions) => {
    const perms = permissions.map(item => {
        if (!item.isOwn) {
            item.isOwn = defaultIsOwn;
        }
        return item;
    });
    return common_1.SetMetadata(authz_constants_1.PERMISSIONS_METADATA, perms);
};
//# sourceMappingURL=use-permissions.decorator.js.map