import * as casbin from 'casbin';
export declare class AuthZManagementService {
    private readonly enforcer;
    constructor(enforcer: casbin.Enforcer);
    getAllSubjects(): Promise<string[]>;
    getAllNamedSubjects(ptype: string): Promise<string[]>;
    getAllObjects(): Promise<string[]>;
    getAllNamedObjects(ptype: string): Promise<string[]>;
    getAllActions(): Promise<string[]>;
    getAllNamedActions(ptype: string): Promise<string[]>;
    getAllRoles(): Promise<string[]>;
    getAllNamedRoles(ptype: string): Promise<string[]>;
    getPolicy(): Promise<string[][]>;
    getFilteredPolicy(fieldIndex: number, ...fieldValues: string[]): Promise<string[][]>;
    getNamedPolicy(ptype: string): Promise<string[][]>;
    getFilteredNamedPolicy(ptype: string, fieldIndex: number, ...fieldValues: string[]): Promise<string[][]>;
    getGroupingPolicy(): Promise<string[][]>;
    getFilteredGroupingPolicy(fieldIndex: number, ...fieldValues: string[]): Promise<string[][]>;
    getNamedGroupingPolicy(ptype: string): Promise<string[][]>;
    getFilteredNamedGroupingPolicy(ptype: string, fieldIndex: number, ...fieldValues: string[]): Promise<string[][]>;
    hasPolicy(...params: string[]): Promise<boolean>;
    hasNamedPolicy(ptype: string, ...params: string[]): Promise<boolean>;
    addPolicy(...params: string[]): Promise<boolean>;
    addPolicies(rules: string[][]): Promise<boolean>;
    addNamedPolicy(ptype: string, ...params: string[]): Promise<boolean>;
    addNamedPolicies(ptype: string, rules: string[][]): Promise<boolean>;
    updatePolicy(oldRule: string[], newRule: string[]): Promise<boolean>;
    updateNamedPolicy(ptype: string, oldRule: string[], newRule: string[]): Promise<boolean>;
    removePolicy(...params: string[]): Promise<boolean>;
    removePolicies(rules: string[][]): Promise<boolean>;
    removeFilteredPolicy(fieldIndex: number, ...fieldValues: string[]): Promise<boolean>;
    removeNamedPolicy(ptype: string, ...params: string[]): Promise<boolean>;
    removeNamedPolicies(ptype: string, rules: string[][]): Promise<boolean>;
    removeFilteredNamedPolicy(ptype: string, fieldIndex: number, ...fieldValues: string[]): Promise<boolean>;
    hasGroupingPolicy(...params: string[]): Promise<boolean>;
    hasNamedGroupingPolicy(ptype: string, ...params: string[]): Promise<boolean>;
    addGroupingPolicy(...params: string[]): Promise<boolean>;
    addGroupingPolicies(rules: string[][]): Promise<boolean>;
    addNamedGroupingPolicy(ptype: string, ...params: string[]): Promise<boolean>;
    addNamedGroupingPolicies(ptype: string, rules: string[][]): Promise<boolean>;
    removeGroupingPolicy(...params: string[]): Promise<boolean>;
    removeGroupingPolicies(rules: string[][]): Promise<boolean>;
    removeFilteredGroupingPolicy(fieldIndex: number, ...fieldValues: string[]): Promise<boolean>;
    removeNamedGroupingPolicy(ptype: string, ...params: string[]): Promise<boolean>;
    removeNamedGroupingPolicies(ptype: string, rules: string[][]): Promise<boolean>;
    removeFilteredNamedGroupingPolicy(ptype: string, fieldIndex: number, ...fieldValues: string[]): Promise<boolean>;
    addFunction(name: string, func: any): Promise<void>;
    loadPolicy(): Promise<void>;
}
