"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
const common_1 = require("@nestjs/common");
const authz_constants_1 = require("../authz.constants");
const casbin = require("casbin");
let AuthZManagementService = class AuthZManagementService {
    constructor(enforcer) {
        this.enforcer = enforcer;
    }
    getAllSubjects() {
        return this.enforcer.getAllSubjects();
    }
    getAllNamedSubjects(ptype) {
        return this.enforcer.getAllNamedSubjects(ptype);
    }
    getAllObjects() {
        return this.enforcer.getAllObjects();
    }
    getAllNamedObjects(ptype) {
        return this.enforcer.getAllNamedObjects(ptype);
    }
    getAllActions() {
        return this.enforcer.getAllActions();
    }
    getAllNamedActions(ptype) {
        return this.enforcer.getAllNamedActions(ptype);
    }
    getAllRoles() {
        return this.enforcer.getAllRoles();
    }
    getAllNamedRoles(ptype) {
        return this.enforcer.getAllNamedRoles(ptype);
    }
    getPolicy() {
        return this.enforcer.getPolicy();
    }
    getFilteredPolicy(fieldIndex, ...fieldValues) {
        return this.enforcer.getFilteredPolicy(fieldIndex, ...fieldValues);
    }
    getNamedPolicy(ptype) {
        return this.enforcer.getNamedPolicy(ptype);
    }
    getFilteredNamedPolicy(ptype, fieldIndex, ...fieldValues) {
        return this.enforcer.getFilteredNamedPolicy(ptype, fieldIndex, ...fieldValues);
    }
    getGroupingPolicy() {
        return this.enforcer.getGroupingPolicy();
    }
    getFilteredGroupingPolicy(fieldIndex, ...fieldValues) {
        return this.enforcer.getFilteredGroupingPolicy(fieldIndex, ...fieldValues);
    }
    getNamedGroupingPolicy(ptype) {
        return this.enforcer.getNamedGroupingPolicy(ptype);
    }
    getFilteredNamedGroupingPolicy(ptype, fieldIndex, ...fieldValues) {
        return this.enforcer.getFilteredNamedGroupingPolicy(ptype, fieldIndex, ...fieldValues);
    }
    hasPolicy(...params) {
        return this.enforcer.hasPolicy(...params);
    }
    hasNamedPolicy(ptype, ...params) {
        return this.enforcer.hasNamedPolicy(ptype, ...params);
    }
    addPolicy(...params) {
        return this.enforcer.addPolicy(...params);
    }
    addPolicies(rules) {
        return this.enforcer.addPolicies(rules);
    }
    addNamedPolicy(ptype, ...params) {
        return this.enforcer.addNamedPolicy(ptype, ...params);
    }
    addNamedPolicies(ptype, rules) {
        return this.enforcer.addNamedPolicies(ptype, rules);
    }
    updatePolicy(oldRule, newRule) {
        return this.enforcer.updatePolicy(oldRule, newRule);
    }
    updateNamedPolicy(ptype, oldRule, newRule) {
        return this.enforcer.updateNamedPolicy(ptype, oldRule, newRule);
    }
    removePolicy(...params) {
        return this.enforcer.removePolicy(...params);
    }
    removePolicies(rules) {
        return this.enforcer.removePolicies(rules);
    }
    removeFilteredPolicy(fieldIndex, ...fieldValues) {
        return this.enforcer.removeFilteredPolicy(fieldIndex, ...fieldValues);
    }
    removeNamedPolicy(ptype, ...params) {
        return this.enforcer.removeNamedPolicy(ptype, ...params);
    }
    removeNamedPolicies(ptype, rules) {
        return this.enforcer.removeNamedPolicies(ptype, rules);
    }
    removeFilteredNamedPolicy(ptype, fieldIndex, ...fieldValues) {
        return this.enforcer.removeFilteredNamedPolicy(ptype, fieldIndex, ...fieldValues);
    }
    hasGroupingPolicy(...params) {
        return this.enforcer.hasGroupingPolicy(...params);
    }
    hasNamedGroupingPolicy(ptype, ...params) {
        return this.enforcer.hasNamedGroupingPolicy(ptype, ...params);
    }
    addGroupingPolicy(...params) {
        return this.enforcer.addGroupingPolicy(...params);
    }
    addGroupingPolicies(rules) {
        return this.enforcer.addGroupingPolicies(rules);
    }
    addNamedGroupingPolicy(ptype, ...params) {
        return this.enforcer.addNamedGroupingPolicy(ptype, ...params);
    }
    addNamedGroupingPolicies(ptype, rules) {
        return this.enforcer.addNamedGroupingPolicies(ptype, rules);
    }
    removeGroupingPolicy(...params) {
        return this.enforcer.removeGroupingPolicy(...params);
    }
    removeGroupingPolicies(rules) {
        return this.enforcer.removeGroupingPolicies(rules);
    }
    removeFilteredGroupingPolicy(fieldIndex, ...fieldValues) {
        return this.enforcer.removeFilteredGroupingPolicy(fieldIndex, ...fieldValues);
    }
    removeNamedGroupingPolicy(ptype, ...params) {
        return this.enforcer.removeNamedGroupingPolicy(ptype, ...params);
    }
    removeNamedGroupingPolicies(ptype, rules) {
        return this.enforcer.removeNamedGroupingPolicies(ptype, rules);
    }
    removeFilteredNamedGroupingPolicy(ptype, fieldIndex, ...fieldValues) {
        return this.enforcer.removeFilteredNamedGroupingPolicy(ptype, fieldIndex, ...fieldValues);
    }
    addFunction(name, func) {
        return this.enforcer.addFunction(name, func);
    }
    loadPolicy() {
        return this.enforcer.loadPolicy();
    }
};
AuthZManagementService = __decorate([
    common_1.Injectable(),
    __param(0, common_1.Inject(authz_constants_1.AUTHZ_ENFORCER)),
    __metadata("design:paramtypes", [casbin.Enforcer])
], AuthZManagementService);
exports.AuthZManagementService = AuthZManagementService;
//# sourceMappingURL=authz-management.service.js.map