import * as casbin from 'casbin';
export declare class AuthZRBACService {
    private readonly enforcer;
    constructor(enforcer: casbin.Enforcer);
    getRolesForUser(name: string, domain?: string): Promise<string[]>;
    getUsersForRole(name: string, domain?: string): Promise<string[]>;
    hasRoleForUser(name: string, role: string, domain?: string): Promise<boolean>;
    addRoleForUser(user: string, role: string, domain?: string): Promise<boolean>;
    deleteRoleForUser(user: string, role: string, domain?: string): Promise<boolean>;
    deleteRolesForUser(user: string, domain?: string): Promise<boolean>;
    deleteUser(user: string): Promise<boolean>;
    deleteRole(role: string): Promise<boolean>;
    deletePermission(...permission: string[]): Promise<boolean>;
    addPermissionForUser(userOrRole: string, ...permission: string[]): Promise<boolean>;
    deletePermissionForUser(userOrRole: string, ...permission: string[]): Promise<boolean>;
    deletePermissionsForUser(userOrRole: string): Promise<boolean>;
    getPermissionsForUser(userOrRole: string): Promise<string[][]>;
    hasPermissionForUser(user: string, ...permission: string[]): Promise<boolean>;
    getImplicitRolesForUser(name: string, ...domain: string[]): Promise<string[]>;
    getImplicitPermissionsForUser(user: string, ...domain: string[]): Promise<string[][]>;
    getImplicitUsersForPermission(...permission: string[]): Promise<string[]>;
}
