"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const common_1 = require("@nestjs/common");
const authz_constants_1 = require("../authz.constants");
const casbin = require("casbin");
let AuthZRBACService = class AuthZRBACService {
    constructor(enforcer) {
        this.enforcer = enforcer;
    }
    getRolesForUser(name, domain) {
        return this.enforcer.getRolesForUser(name, domain);
    }
    getUsersForRole(name, domain) {
        return this.enforcer.getUsersForRole(name, domain);
    }
    hasRoleForUser(name, role, domain) {
        return this.enforcer.hasRoleForUser(name, role, domain);
    }
    addRoleForUser(user, role, domain) {
        return this.enforcer.addRoleForUser(user, role, domain);
    }
    deleteRoleForUser(user, role, domain) {
        return this.enforcer.deleteRoleForUser(user, role, domain);
    }
    deleteRolesForUser(user, domain) {
        return this.enforcer.deleteRolesForUser(user, domain);
    }
    deleteUser(user) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.enforcer.deleteUser(user);
        });
    }
    deleteRole(role) {
        return this.enforcer.deleteRole(role);
    }
    deletePermission(...permission) {
        return this.enforcer.deletePermission(...permission);
    }
    addPermissionForUser(userOrRole, ...permission) {
        return this.enforcer.addPermissionForUser(userOrRole, ...permission);
    }
    deletePermissionForUser(userOrRole, ...permission) {
        return this.enforcer.deletePermissionForUser(userOrRole, ...permission);
    }
    deletePermissionsForUser(userOrRole) {
        return this.enforcer.deletePermissionsForUser(userOrRole);
    }
    getPermissionsForUser(userOrRole) {
        return this.enforcer.getPermissionsForUser(userOrRole);
    }
    hasPermissionForUser(user, ...permission) {
        return this.enforcer.hasPermissionForUser(user, ...permission);
    }
    getImplicitRolesForUser(name, ...domain) {
        return this.enforcer.getImplicitRolesForUser(name, ...domain);
    }
    getImplicitPermissionsForUser(user, ...domain) {
        return this.enforcer.getImplicitPermissionsForUser(user, ...domain);
    }
    getImplicitUsersForPermission(...permission) {
        return this.enforcer.getImplicitUsersForPermission(...permission);
    }
};
AuthZRBACService = __decorate([
    common_1.Injectable(),
    __param(0, common_1.Inject(authz_constants_1.AUTHZ_ENFORCER)),
    __metadata("design:paramtypes", [casbin.Enforcer])
], AuthZRBACService);
exports.AuthZRBACService = AuthZRBACService;
//# sourceMappingURL=authz-rbac.service.js.map